'use strict';

var auth = require('./lib/httpclient/auth');
var helpers = require('./lib/httpclient/helpers');
var TuTrabajoClient = require('./lib/httpclient/client');
var deprecationWrapper = function (url, options) {
  helpers.log('This is deprecated, use "new TuTrabajoClient" instead.');

  return new TuTrabajoClient(url, options);
};

/* Here for IE8 Support */
if (!Array.prototype.indexOf) {
  Array.prototype.indexOf = function(obj, start) {
    for (var i = (start || 0), j = this.length; i < j; i++) {
      if (this[i] === obj) { return i; }
    }
    return -1;
  };
}

/* Here for IE8 Support */
if (!String.prototype.trim) {
  String.prototype.trim = function () {
    return this.replace(/^\s+|\s+$/g, '');
  };
}

/* Here for node 10.x support */
if (!String.prototype.endsWith) {
  String.prototype.endsWith = function(suffix) {
    return this.indexOf(suffix, this.length - suffix.length) !== -1;
  };
}

module.exports = TuTrabajoClient;

TuTrabajoClient.ApiKeyAuthorization = auth.ApiKeyAuthorization;
TuTrabajoClient.PasswordAuthorization = auth.PasswordAuthorization;
TuTrabajoClient.CookieAuthorization = auth.CookieAuthorization;
TuTrabajoClient.TuTrabajoApi = deprecationWrapper;
TuTrabajoClient.TuTrabajoClient = deprecationWrapper;
TuTrabajoClient.SchemaMarkup = require('./lib/httpclient/schema-markup');
